/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package demoviewer.model;

import demoviewer.model.database.DatabaseConnector;
import demoviewer.model.database.ResultSetWrapper;
import demoviewer.model.label.ShadowLabel;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Me
 */
public class Frag {
   
    public static final int KILL_TYPE_BLUE = 0;
    public static final int KILL_TYPE_RED = 1;
    public static final int KILL_TYPE_POV = 2;
    
    public static final int TEAM_KILL_NO = 0;
    public static final int TEAM_KILL_YES = 1;
        
    private int id = -1;
    private int demoId = -1;
    private long roundTime = -1;
    private long frameTime = -1;
    private int attackerId = -1;
    private int targetId = -1;
    private String attackerName = "";
    private String targetName = "";
    private String message = "";
    private int weapon = -1;
    private int killType = -1;
    private int teamKill = -1;
    
    private boolean lastFragInSpree = false;
    
    private ShadowLabel fragLabel = null;
    
    public static List<Frag> getFragsForDemoId(int demoId) throws SQLException, ClassNotFoundException {
                
        List<Frag> frags = new ArrayList<>();
        
        ResultSetWrapper rsw = null;
        
        try {
            
            Connection connection = DatabaseConnector.getConnection();
            connection.setAutoCommit(false);
            PreparedStatement ps = connection.prepareStatement("select * from frag where demo_id = ?;");
            ps.setInt(1, demoId);
            ResultSet resultSet = ps.executeQuery();
            rsw = new ResultSetWrapper(connection, resultSet);
            
            while (resultSet.next()) {
                
                Frag frag = new Frag();
                frag.initFromResultSet(resultSet);                
                frags.add(frag);
            }            
        }
        finally {
            
            if (rsw != null) {
                rsw.close();
            }            
        }

        return frags;        
    }
    
    private void initFromResultSet(ResultSet resultSet) throws SQLException {
        
        id = resultSet.getInt("id");
        demoId = resultSet.getInt("demo_id");
        roundTime = resultSet.getLong("round_time");
        frameTime = resultSet.getLong("frame_time");
        attackerId = resultSet.getInt("attacker");  
        targetId = resultSet.getInt("target");     
        attackerName = resultSet.getString("attacker_name"); 
        targetName = resultSet.getString("target_name"); 
        message = resultSet.getString("message");
        weapon = resultSet.getInt("weapon");
        killType = resultSet.getInt("killtype");  
        teamKill = resultSet.getInt("teamkill");
        
        fragLabel = new ShadowLabel();
        fragLabel.setText(message); 
    }
    
    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public int getDemoId() {
        return demoId;
    }
    
    public void setDemoId(int demoId) {
        this.demoId = demoId;
    }

    public long getRoundTime() {
        return roundTime;
    }

    public void setRoundTime(long roundTime) {
        this.roundTime = roundTime;
    }
    
    public long getFrameTime() {
        return frameTime;
    }

    public void setFrameTime(long frameTime) {
        this.frameTime = frameTime;
    }

    public int getAttackerId() {
        return attackerId;
    }

    public void setAttackerId(int attackerId) {
        this.attackerId = attackerId;
    }

    public int getTargetId() {
        return targetId;
    }

    public void setTargetId(int targetId) {
        this.targetId = targetId;
    }

    public String getAttackerName() {
        return attackerName;
    }

    public void setAttackerName(String attackerName) {
        this.attackerName = attackerName;
    }

    public String getTargetName() {
        return targetName;
    }

    public void setTargetName(String targetName) {
        this.targetName = targetName;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public int getWeapon() {
        return weapon;
    }

    public void setWeapon(int weapon) {
        this.weapon = weapon;
    }
    
    public int getKillType() {
        return killType;
    }

    public void setKillType(int killType) {
        this.killType = killType;
    }

    public int getTeamKill() {
        return teamKill;
    }

    public void setTeamKill(int teamKill) {
        this.teamKill = teamKill;
    }
    
    public boolean isLastFragInSpree() {
        return lastFragInSpree;
    }

    public void setLastFragInSpree(boolean lastFragInSpree) {
        this.lastFragInSpree = lastFragInSpree;
    }
    
    public ShadowLabel getFragLabel() {
        return fragLabel;
    }

    public void setFragLabel(ShadowLabel fragLabel) {
        this.fragLabel = fragLabel;
    }
}
