/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package demoviewer.model.tables;

import demoviewer.model.Frag;
import demoviewer.utils.StringUtils;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author Me
 */
public class FragTableModel extends AbstractTableModel {
    
    public static final int COLUMN_ATTACKER_ID = 2;
    public static final int COLUMN_TARGET_ID = 3;
    public static final int COLUMN_WEAPON = 4;
    public static final int COLUMN_TEAM_KILL = 5;
    public static final int COLUMN_FRAG_ID = 6;
    public static final int COLUMN_LAST_IN_SPREE = 7;
    
    private static final String[] COLUMN_NAMES = {"Time", "Message", "Attacker ID", "Target ID", "Weapon", "Team Kill", "Frag ID", "Last In Spree"};
    
    private List<Frag> frags = null;
    
    public FragTableModel(List<Frag> frags) {        
        this.frags = frags;
    }

    @Override
    public int getRowCount() {
        return frags.size();
    }

    @Override
    public int getColumnCount() {
        return COLUMN_NAMES.length;
    }
    
    @Override
    public String getColumnName(int columnIndex) {
        return COLUMN_NAMES[columnIndex];
    }
    
   @Override
    public Class<?> getColumnClass(int columnIndex) {

        switch (columnIndex) {
            case 0:
                return String.class;
            case 1:
                return String.class;
            case 2:
                return Integer.class;
            case 3:
                return Integer.class;
            case 4:
                return Integer.class;
            case 5:
                return Integer.class;
            case 6:
                return Integer.class;
            case 7:
                return Boolean.class;
            default:
                return String.class;
        }
    }
   
    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return false;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
      
        Frag frag = frags.get(rowIndex);
        
        switch (columnIndex) {
            case 0:
                return StringUtils.getStringFromMillis(frag.getRoundTime());
            case 1:
                return frag.getMessage();
            case 2:
                return frag.getAttackerId();
            case 3:
                return frag.getTargetId();
            case 4:
                return frag.getWeapon();
            case 5:
                return frag.getTeamKill();
            case 6:
                return frag.getId();
            case 7:
                return frag.isLastFragInSpree();
            default:
                return "";
        }                
    }  
        
    public List<Frag> getFrags() {
        return frags;
    }

    public void setFrags(List<Frag> frags) {
        this.frags = frags;
    }
    
    public void setFrag(int rowIndex, Frag frag) {
        frags.set(rowIndex, frag);
    }
}
