/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package demoviewer.model.tables;

import demoviewer.model.Player;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author Me
 */
public class PlayerTableModel extends AbstractTableModel {
    
    private static final String[] COLUMN_NAMES = {"ID", "Player Name", "Team", ""};
    
    private List<Player> players = null;
    
    public PlayerTableModel(List<Player> players) {        
        this.players = players;
    }

    @Override
    public int getRowCount() {
        return players.size();
    }

    @Override
    public int getColumnCount() {
        return COLUMN_NAMES.length;
    }
    
    @Override
    public String getColumnName(int columnIndex) {
        return COLUMN_NAMES[columnIndex];
    }
    
   @Override
    public Class<?> getColumnClass(int columnIndex) {

        switch (columnIndex) {
            case 0:
                return String.class;
            case 1:
                return String.class;
            case 2:
                return String.class;
            case 3:
                return Boolean.class;
            default:
                return String.class;
        }
    }
   
    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        
        if (columnIndex == 3) {
            return true;
        }
        
        return false;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
      
        Player player = players.get(rowIndex);
        
        switch (columnIndex) {
            case 0:
                return Integer.toString(player.getPlayerId());
            case 1:
                return player.getPlayerName();
            case 2:
                return player.getTeamAsString();
            case 3:
                return player.isSelected();
            default:
                return "";
        }                
    } 
    
    @Override
    public void setValueAt(Object value, int rowIndex, int columnIndex) {
        
        if (columnIndex == 3 && value instanceof Boolean) {
            Boolean selected = (Boolean) value;
            players.get(rowIndex).setSelected(selected);
        }        
    }
    
    public List<Player> getPlayers() {
        return players;
    }

    public void setPlayers(List<Player> players) {
        this.players = players;
    }
}
