/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package demoviewer.model.tree;

import javax.swing.tree.TreePath;
import org.jdesktop.swingx.treetable.AbstractTreeTableModel;

/**
 *
 * @author Me
 */
public class FragTreeTableModel extends AbstractTreeTableModel {

    private static final String[] COLUMN_NAMES = {"Sprees"};
        
    public FragTreeTableModel(Object root) {
        super(root);
    }

    @Override
    public int getColumnCount() {
        return COLUMN_NAMES.length;
    }

    @Override
    public String getColumnName(int columnIndex) {
        return COLUMN_NAMES[columnIndex];
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {

        switch (columnIndex) {
            case 0:
                return FragTreeNode.class;
            default:
                return String.class;
        }
    }

    @Override
    public boolean isCellEditable(Object node, int columnIndex) {
        return false;
    }

    @Override
    public Object getValueAt(Object object, int columnIndex) {

        Node node = (Node)object;
        if (node instanceof SpreeTreeNode) {
            SpreeTreeNode spreeTreeNode = (SpreeTreeNode)node;
            return getValueAtForSpreeTreeNode(spreeTreeNode, columnIndex);
        }
        else if (node instanceof FragTreeNode) {
            FragTreeNode fragTreeNode = (FragTreeNode)node;
            return getValueAtForFragTreeNode(fragTreeNode, columnIndex);
        }

        return "";
    }
    
    public Object getValueAtForSpreeTreeNode(SpreeTreeNode spreeTreeNode, int columnIndex) {

        switch (columnIndex) {
            case 0:
                return spreeTreeNode;
            default:
                return "";
        } 
    }

    public Object getValueAtForFragTreeNode(FragTreeNode fragTreeNode, int columnIndex) {

        switch (columnIndex) {
            case 0:
                return fragTreeNode;
            default:
                return "";
        } 
    }
    
    @Override
    public Object getChild(Object parent, int index) {

        Node node = (Node)parent;
        return node.getChildAt(index);
    }

    @Override
    public int getChildCount(Object parent) {

        Node node = (Node)parent;
        return node.getChildCount();
    }

    @Override
    public int getIndexOfChild(Object parent, Object child) {

        Node node = (Node)parent;
        Node childNode = (Node)child;
        return node.getIndex(childNode);
    }
    
    public void refreshRootNode() {

        Node rootNode = (Node)getRoot();
        TreePath treePath = new TreePath(rootNode.getPath());
        valueForPathChanged(treePath, rootNode);
    }
    
    public void refreshNode(Node node) {

        TreePath treePath = new TreePath(node.getPath());
        valueForPathChanged(treePath, node);
    }
}
