/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package demoviewer.model.tree;

import java.util.ArrayList;
import java.util.List;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 *
 * @author Me
 */
public class Node extends DefaultMutableTreeNode {

    public List<Node> getChildren() {
        
        List<Node> childList = new ArrayList<Node>(); 
        populateChildList(childList, this, 0, 1);         
        
        return childList;
    }
    
    public List<Node> getAllChildren() {
        
        List<Node> childList = new ArrayList<Node>(); 
        populateChildList(childList, this, 0, -1);         
        
        return childList;
    }
    
    public void populateChildList(List<Node> childList, Node node, int level, int levelLimit) {
        
        if (node.isLeaf() || level == levelLimit) {
            return;
        }
        
        level++;
        
        for (int i = 0; i < node.getChildCount(); i++) {
            Node child = (Node)node.getChildAt(i);
            childList.add(child);
            populateChildList(childList, child, level, levelLimit);  
        }        
    }
    
    public List<Node> getParents() {
        
        List<Node> parents = new ArrayList<Node>();
        populateParentList(parents, this); 
        
        return parents;
    }
    
    public int getNumberOfParents() {
        
        List<Node> parents = new ArrayList<Node>();
        populateParentList(parents, this); 
        
        return parents.size();
    }
    
    public void populateParentList(List<Node> parents, Node node) {
        
        if (node.isRoot()) {
            return;
        }
        
        Node parentNode = (Node)node.getParent();
        parents.add(parentNode);
        
        populateParentList(parents, parentNode);
    }    
}
