/*
 * ColouredTextPanel.java
 *
 * Created on Nov 8, 2012, 7:41:48 PM
 */
package demoviewer.panels;

import java.awt.Color;
import java.util.HashMap;
import javax.swing.JPanel;
import javax.swing.text.AttributeSet;
import javax.swing.text.DefaultHighlighter;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyleContext;

/**
 *
 * @author Me
 */
public class ColorTextPanel extends JPanel {

    private HashMap<Character, Color> colorMap = null;
    
    private String text = "";

    private ColorTextPanel() {
        initComponents();
    }

    public ColorTextPanel(String text) {

        this();
        
        this.text = text;
        
        init();
    }
    
    private void init() {
                
        if (txtPane.getHighlighter() == null) {
            txtPane.setHighlighter(new DefaultHighlighter());  
        }   
        
        initColorMap();        
        setColoredText();   
    }

    private void initColorMap() {

        colorMap = new HashMap<>();

        colorMap.put('0', new Color(0x000000));
        colorMap.put('P', new Color(0x000000));
        colorMap.put('p', new Color(0x000000));

        colorMap.put('1', new Color(0xFF0000));
        colorMap.put('Q', new Color(0xFF0000));
        colorMap.put('q', new Color(0xFF0000));

        colorMap.put('2', new Color(0x00FF00));
        colorMap.put('R', new Color(0x00FF00));
        colorMap.put('r', new Color(0x00FF00));

        colorMap.put('3', new Color(0xFFFF00));
        colorMap.put('S', new Color(0xFFFF00));
        colorMap.put('s', new Color(0xFFFF00));

        colorMap.put('4', new Color(0x0000FF));
        colorMap.put('T', new Color(0x0000FF));
        colorMap.put('t', new Color(0x0000FF));

        colorMap.put('5', new Color(0x00FFFF));
        colorMap.put('U', new Color(0x00FFFF));
        colorMap.put('u', new Color(0x00FFFF));

        colorMap.put('6', new Color(0xFF00FF));
        colorMap.put('V', new Color(0xFF00FF));
        colorMap.put('v', new Color(0xFF00FF));

        colorMap.put('7', new Color(0xFFFFFF));
        colorMap.put('W', new Color(0xFFFFFF));
        colorMap.put('w', new Color(0xFFFFFF));

        colorMap.put('8', new Color(0xFF7F00));
        colorMap.put('X', new Color(0xFF7F00));
        colorMap.put('x', new Color(0xFF7F00));

        colorMap.put('9', new Color(0x7F7F7F));
        colorMap.put('Y', new Color(0x7F7F7F));
        colorMap.put('y', new Color(0x7F7F7F));

        colorMap.put(':', new Color(0xBFBFBF));
        colorMap.put('Z', new Color(0xBFBFBF));
        colorMap.put('z', new Color(0xBFBFBF));
        colorMap.put(';', new Color(0xBFBFBF));
        colorMap.put('[', new Color(0xBFBFBF));
        colorMap.put('{', new Color(0xBFBFBF));

        colorMap.put('<', new Color(0x007F00));
        colorMap.put('|', new Color(0x007F00));

        colorMap.put('=', new Color(0x7F7F00));
        colorMap.put(']', new Color(0x7F7F00));
        colorMap.put('}', new Color(0x7F7F00));

        colorMap.put('>', new Color(0x00007F));
        colorMap.put('~', new Color(0x00007F));

        colorMap.put('?', new Color(0x7F0000));
        colorMap.put('_', new Color(0x7F0000));

        colorMap.put('@', new Color(0x7F3F00));

        colorMap.put('!', new Color(0xFF9919));
        colorMap.put('A', new Color(0xFF9919));
        colorMap.put('a', new Color(0xFF9919));

        colorMap.put('\"', new Color(0x007F7F));
        colorMap.put('B', new Color(0x007F7F));
        colorMap.put('b', new Color(0x007F7F));

        colorMap.put('#', new Color(0x7F007F));
        colorMap.put('C', new Color(0x7F007F));
        colorMap.put('c', new Color(0x7F007F));

        colorMap.put('$', new Color(0x007fff));
        colorMap.put('D', new Color(0x007fff));
        colorMap.put('d', new Color(0x007fff));

        colorMap.put('%', new Color(0x7f00ff));
        colorMap.put('E', new Color(0x7f00ff));
        colorMap.put('e', new Color(0x7f00ff));

        colorMap.put('&', new Color(0x3399cc));
        colorMap.put('F', new Color(0x3399cc));
        colorMap.put('f', new Color(0x3399cc));

        colorMap.put('\"', new Color(0xccffcc));
        colorMap.put('G', new Color(0xccffcc));
        colorMap.put('g', new Color(0xccffcc));

        colorMap.put('(', new Color(0x006633));
        colorMap.put('H', new Color(0x006633));
        colorMap.put('h', new Color(0x006633));

        colorMap.put(')', new Color(0xff0033));
        colorMap.put('I', new Color(0xff0033));
        colorMap.put('i', new Color(0xff0033));

        colorMap.put('*', new Color(0xb21919));
        colorMap.put('J', new Color(0xb21919));
        colorMap.put('j', new Color(0xb21919));

        colorMap.put('+', new Color(0x993300));
        colorMap.put('K', new Color(0x993300));
        colorMap.put('k', new Color(0x993300));

        colorMap.put(',', new Color(0xcc9933));
        colorMap.put('L', new Color(0xcc9933));
        colorMap.put('l', new Color(0xcc9933));

        colorMap.put('-', new Color(0x999933));
        colorMap.put('M', new Color(0x999933));
        colorMap.put('m', new Color(0x999933));

        colorMap.put('.', new Color(0xffffbf));
        colorMap.put('N', new Color(0xffffbf));
        colorMap.put('n', new Color(0xffffbf));

        colorMap.put('/', new Color(0xffff7f));
        colorMap.put('O', new Color(0xffff7f));
        colorMap.put('o', new Color(0xffff7f));
    }
    
    public void setColoredText() {

        char[] chars = text.toCharArray();

        boolean escapeChar = false;
        Color color = Color.WHITE;

        for (int i = 0; i < chars.length; i++) {

            if (escapeChar) {                
                color = colorMap.get(chars[i]);
                escapeChar = false;
                i++;
            } 
            else if (chars[i] == '^') {
                escapeChar = true;
            }

            if (!escapeChar && (i != chars.length) && chars[i] != '^') {
                append(chars[i], color);
            } 
            else if (!escapeChar && (i != chars.length) && chars[i] == '^') {
                i--;
            } 
            else if (escapeChar && (i != chars.length - 1)) {
                
                i++;
                
                if (chars[i] != '^') {
                    i--;
                }
            }
        }
    }
            
    public void append(char c, Color color) {
        
        StyleContext sc = StyleContext.getDefaultStyleContext();
        AttributeSet aset = sc.addAttribute(SimpleAttributeSet.EMPTY, StyleConstants.Foreground, color);

        int len = txtPane.getDocument().getLength();
        txtPane.setCaretPosition(len);
        txtPane.setCharacterAttributes(aset, false);
        
        String str = "" + c;
        txtPane.replaceSelection(str);
    }
        
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        txtPane = new javax.swing.JTextPane();

        setBackground(new java.awt.Color(102, 102, 102));
        setBorder(javax.swing.BorderFactory.createEmptyBorder(7, 7, 7, 7));
        setForeground(new java.awt.Color(255, 255, 255));
        setName("Form"); // NOI18N
        setLayout(new java.awt.BorderLayout());

        txtPane.setBackground(new java.awt.Color(128, 128, 128));
        txtPane.setBorder(null);
        txtPane.setFont(new java.awt.Font("Verdana", 1, 11)); // NOI18N
        txtPane.setName("txtPane"); // NOI18N
        txtPane.setOpaque(false);
        add(txtPane, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextPane txtPane;
    // End of variables declaration//GEN-END:variables
}
