/*
 * PlayerTablePanel.java
 *
 * Created on Nov 24, 2012, 12:20:03 PM
 */
package demoviewer.panels;

import demoviewer.common.Borders;
import demoviewer.common.Colors;
import demoviewer.model.MeansOfDeath;
import demoviewer.model.tables.FragTableModel;
import demoviewer.model.tables.MeansOfDeathTableModel;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.util.ArrayList;
import java.util.List;
import javax.swing.DefaultCellEditor;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.RowFilter;
import javax.swing.table.DefaultTableCellRenderer;

/**
 *
 * @author Me
 */
public class MeansOfDeathTablePanel extends javax.swing.JPanel {

    public MeansOfDeathTablePanel() {
        initComponents();
        init();
    }

    private void init() {
        initTable();
    }

    private void initTable() {

        MeansOfDeathTableModel meansOfDeathTableModel = new MeansOfDeathTableModel(MeansOfDeath.getMeansOfDeath());
        table.setModel(meansOfDeathTableModel);
        table.setRowHeight(20);
        table.setSelectionBackground(Colors.COLOR_TABLE_ROW_SELECTED);
        table.setFocusable(false);
        
        table.setDefaultEditor(Boolean.class, new DefaultCheckBoxEditor());
        table.setAutoCreateRowSorter(true);
        table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        table.setIntercellSpacing(new Dimension (0, 0));
        
        DefaultRenderer defaultRenderer = new DefaultRenderer();
        for (int i = 0; i < table.getColumnCount(); i++) {
            table.getColumnModel().getColumn(i).setCellRenderer(defaultRenderer);
        }
        
        setTableColumnWidths();
    }
    
    private void setTableColumnWidths() {
                        
        table.getColumnModel().getColumn(1).setMinWidth(30);
        table.getColumnModel().getColumn(1).setMaxWidth(30);     
    }
    
    private void setSelectedAll(boolean selected) {
        
        MeansOfDeathTableModel meansOfDeathTableModel = (MeansOfDeathTableModel)table.getModel();       
        for (MeansOfDeath meansOfDeath : meansOfDeathTableModel.getMeansOfDeath()) {
            meansOfDeath.setSelected(selected);
        }
        
        meansOfDeathTableModel.fireTableDataChanged(); 
    }
    
    public RowFilter<Object,Object> getFilters() {
                
        List<RowFilter<Object,Object>> filters = new ArrayList<>();
        
        MeansOfDeathTableModel meansOfDeathTableModel = (MeansOfDeathTableModel)table.getModel();       
        for (MeansOfDeath mod : meansOfDeathTableModel.getMeansOfDeath()) {
            if (mod.isSelected()) {
                filters.add(RowFilter.numberFilter(RowFilter.ComparisonType.EQUAL, mod.getMod(), FragTableModel.COLUMN_WEAPON));
            }
        }
        
        RowFilter<Object,Object> filter = RowFilter.orFilter(filters);
        
        return filter;
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jpBorderLayout = new javax.swing.JPanel();
        jpTableHolder = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        table = new javax.swing.JTable();
        jpToolbatHolder = new javax.swing.JPanel();
        jToolBar1 = new javax.swing.JToolBar();
        btnSelectAll = new javax.swing.JButton();
        btnSelectNone = new javax.swing.JButton();
        jpEnable = new javax.swing.JPanel();
        ckbUseWeaponFilter = new javax.swing.JCheckBox();

        setBorder(javax.swing.BorderFactory.createTitledBorder("Weapons"));
        setLayout(new java.awt.BorderLayout());

        jpBorderLayout.setBorder(javax.swing.BorderFactory.createEmptyBorder(5, 5, 5, 5));
        jpBorderLayout.setLayout(new java.awt.BorderLayout(0, 3));

        jpTableHolder.setLayout(new java.awt.BorderLayout());

        table.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(table);

        jpTableHolder.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jpBorderLayout.add(jpTableHolder, java.awt.BorderLayout.CENTER);

        jpToolbatHolder.setPreferredSize(new java.awt.Dimension(10, 30));
        jpToolbatHolder.setLayout(new java.awt.BorderLayout());

        jToolBar1.setFloatable(false);
        jToolBar1.setRollover(true);

        btnSelectAll.setIcon(new javax.swing.ImageIcon(getClass().getResource("/demoviewer/resources/icons/check_all.png"))); // NOI18N
        btnSelectAll.setToolTipText("Select All");
        btnSelectAll.setFocusable(false);
        btnSelectAll.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnSelectAll.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnSelectAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSelectAllActionPerformed(evt);
            }
        });
        jToolBar1.add(btnSelectAll);

        btnSelectNone.setIcon(new javax.swing.ImageIcon(getClass().getResource("/demoviewer/resources/icons/check_none.png"))); // NOI18N
        btnSelectNone.setToolTipText("Deselect All");
        btnSelectNone.setFocusable(false);
        btnSelectNone.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnSelectNone.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnSelectNone.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSelectNoneActionPerformed(evt);
            }
        });
        jToolBar1.add(btnSelectNone);

        jpToolbatHolder.add(jToolBar1, java.awt.BorderLayout.CENTER);

        jpEnable.setLayout(new java.awt.BorderLayout());

        ckbUseWeaponFilter.setText("Enable Weapon Filter");
        ckbUseWeaponFilter.setFocusable(false);
        jpEnable.add(ckbUseWeaponFilter, java.awt.BorderLayout.CENTER);

        jpToolbatHolder.add(jpEnable, java.awt.BorderLayout.EAST);

        jpBorderLayout.add(jpToolbatHolder, java.awt.BorderLayout.NORTH);

        add(jpBorderLayout, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void btnSelectAllActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSelectAllActionPerformed
        setSelectedAll(true);
    }//GEN-LAST:event_btnSelectAllActionPerformed

    private void btnSelectNoneActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSelectNoneActionPerformed
        setSelectedAll(false);
    }//GEN-LAST:event_btnSelectNoneActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnSelectAll;
    private javax.swing.JButton btnSelectNone;
    private javax.swing.JCheckBox ckbUseWeaponFilter;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JPanel jpBorderLayout;
    private javax.swing.JPanel jpEnable;
    private javax.swing.JPanel jpTableHolder;
    private javax.swing.JPanel jpToolbatHolder;
    private javax.swing.JTable table;
    // End of variables declaration//GEN-END:variables
    
    private class DefaultRenderer extends DefaultTableCellRenderer {
        
        @Override
        public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int rowIndex, int columnIndex) {

            JPanel panel = new JPanel();
            panel.setLayout(new BorderLayout());
            panel.setBorder(Borders.EMPTY_BORDER);
                        
            if (isSelected) {
                panel.setBackground(Colors.COLOR_TABLE_ROW_SELECTED);
            }
            else {
                panel.setBackground(getColorForRow(rowIndex));
            }
            
            if (value instanceof Boolean) {
                JCheckBox checkBox = new JCheckBox();
                checkBox.setHorizontalAlignment(JCheckBox.CENTER);
                checkBox.setSelected((Boolean)value);
                checkBox.setOpaque(false);
                panel.add(checkBox, BorderLayout.CENTER);
            }
            else {            
                JComponent component = (JComponent)super.getTableCellRendererComponent(table, value, isSelected, hasFocus, rowIndex, columnIndex);
                component.setOpaque(false);            
                panel.add(component, BorderLayout.CENTER);
            }
            
            return panel;
        }
        
        private Color getColorForRow(int rowIndex) {
            
            if (rowIndex % 2 == 0) {
                return Colors.COLOR_TABLE_ROW_EVEN;
            }
            
            return Colors.COLOR_TABLE_ROW_ODD;           
        }
    }
    
    private static class DefaultCheckBoxEditor extends DefaultCellEditor {

        private JCheckBox checkBox = null;

        public DefaultCheckBoxEditor() {
            super(new JCheckBox());
            this.checkBox = (JCheckBox)getComponent();
        }

        @Override
        public Object getCellEditorValue() {
            return checkBox.isSelected();
        }

        @Override
        public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int rowIndex, int columnIndex) { 

            checkBox = (JCheckBox)super.getTableCellEditorComponent(table, value, isSelected, rowIndex, columnIndex);
            
            checkBox.setHorizontalAlignment(JCheckBox.CENTER);
            checkBox.setBackground(Colors.COLOR_TABLE_ROW_SELECTED);
            checkBox.setFocusable(false);
            
            return checkBox;
        }
    }
}
