/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package demoviewer.utils;

import java.io.File;
import java.text.DecimalFormat;

/**
 *
 * @author Me
 */
public class FileUtils {
    
    private static final String[] FILE_SIZE_UNITS = new String[]{"B", "KB", "MB", "GB", "TB"};
    
    public static String getFileSizeAsString(File file) {

        long size = file.length();

        if (size <= 0) {
            return "";
        }        

        int digitGroups = (int)(Math.log10(size) / Math.log10(1024));
        
        return new DecimalFormat("#,##0.#").format(size / Math.pow(1024, digitGroups)) + " " + FILE_SIZE_UNITS[digitGroups];
    }  
    
    public static String getFileNameWithoutExtension(File file) {      
        
        String str = file.getName();        
        str = str.substring(0, str.lastIndexOf("."));    
        
        return str;
    }
    
    public static String getFileExtension(File file) {      
        
        String str = file.getAbsolutePath();        
        str = str.substring(str.lastIndexOf(".") + 1, str.length());    
        
        return str;
    }
}
